<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" date-date="" date-date-format="DD/MM/YYYY" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-2">
		  <button id="update_data" class="btn btn-info">Update Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="create_data" class="btn btn-success">Create Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="delete_data" class="btn btn-danger">Delete Data</button>
		</div>
		<div class="col-sm-2">
		  <button id="delete_all_data" class="btn btn-danger">Delete All Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
	"use strict";
	const gBASE_URL = "http://localhost:8080/api/vouchers";
	var gObjectVoucher = [];
	var vId = 0;
	var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maVoucher"},
				{"data":"phanTramGiamGia"},
				{"data":"ghiChu"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
			]
		});
	$(document).ready(function(){
		callApiAllVouchers();
		
		$('#user-table').on('click', 'tr', function(){
        vId = $(this).find('td:first').text();
        loadVoucherDataById(vId);
    });

		$('#update_data').on('click', function(){
				var vObj ={
					maVoucher:0,
					phanTramGiamGia:0,
					ghiChu:"",
					ngayTao:"",
					ngayCapNhat:"",
				}
				getDataForm(vObj);
        getUpdateDataApi(vId, vObj);
				resetForm();
    });
		
		$('#create_data').on('click', function(){
				var vObj ={
					maVoucher:0,
					phanTramGiamGia:0,
					ghiChu:"",
					ngayTao:"",
					ngayCapNhat:"",
				}
				getDataForm(vObj);
				var vIsValidate = validateData(vObj);
				if(vIsValidate){
					getCreateDataApi(vObj);
					resetForm();
				}
    });
		
		$('#delete_data').on('click', function(){
			deleteVoucherById(vId);
			resetForm();
    });
	
		$('#delete_all_data').on('click', function(){
			deleteAllVoucherById();
    });
	});

	function callApiAllVouchers(){
		$.ajax({
			url: gBASE_URL,
			type: "GET",
			dataType: "json",
			success: function(res){
				gObjectVoucher= res;
				DisplayOrderToTable(res);
			},
			error: function(err){
				console.log(err.response);
			}
		});
	}
	function loadVoucherDataById(id) {
			fetch(`http://localhost:8080/api/vouchers/${id}`)
			.then(response => response.json())
			.then(data => {
				// Hiển thị thông tin voucher lên form
				$('#input-voucher-code').val(data.maVoucher);
				$('#input-discount').val(data.phanTramGiamGia);
				$('#input-note').val(data.ghiChu);
				$('#input-createDate').val(data.ngayTao);
				$('#input-updateDate').val(data.ngayCapNhat);
			})
			.catch(error => console.error(error));
		}
	function getUpdateDataApi(pId, pObject) {
			$.ajax({
				url: gBASE_URL+pId,
				type: "PUT",
				contentType: "application/json;charset=UTF-8",
    		data: JSON.stringify(pObject),
				success: function(res){
					callApiAllVouchers();
				},
				error: function(err){
					console.log(err.response);
				}
			});
		}
	function getDataForm(paramObj){
		paramObj.maVoucher = $('#input-voucher-code').val();
		paramObj.phanTramGiamGia = $('#input-discount').val();
		paramObj.ghiChu = $('#input-note').val();
		paramObj.ngayTao = $('#input-createDate').val();
		paramObj.ngayCapNhat = $('#input-updateDate').val();
	}
	function DisplayOrderToTable(paramData) {
			"use strict";
			$("#user-table").DataTable().clear(); // xóa dữ liệu
			$("#user-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
			$("#user-table").DataTable().draw(); //vẽ lại bảng
		}
	function getCreateDataApi(pObject) {
		$.ajax({
			url: gBASE_URL,
			type: "POST",
			contentType: "application/json;charset=UTF-8",
			data: JSON.stringify(pObject),
			success: function(res){
				callApiAllVouchers();
			},
			error: function(err){
				console.log(err.response);
			}
		});
	}
	function validateData(paramObj){
		if(paramObj.maVoucher == 0){
			alert("Bạn chưa điền mã voucher!");
    	return false;
		}
		if(paramObj.phanTramGiamGia == 0){
			alert("Bạn chưa điền phần trăm giảm giá!");
    	return false;
		}
		if(paramObj.ghiChu == ""){
			alert("Bạn chưa điền ghi chú!");
    	return false;
		}
		if(paramObj.ngayTao == ""){
			alert("Bạn chưa điền ngày tạo!");
    	return false;
		}
		if(paramObj.ngayCapNhat == ""){
			alert("Bạn chưa điền ngày cập nhật!");
    	return false;
		}
		return true;
	}
	function resetForm(){
		$('#input-voucher-code').val("");
		$('#input-discount').val("");
		$('#input-note').val("");
		$('#input-createDate').val("");
		$('#input-updateDate').val("");
	}
	function deleteVoucherById(pId) {
		$.ajax({
			url: gBASE_URL + "/" + pId,
			type: "DELETE",
			async: false,
			success: function (paramOrderRes) {
				callApiAllVouchers();
			},
			error: function (paramErr) {
				console.log(paramErr.status);
			},
		});
	}
	function deleteAllVoucherById() {
		$.ajax({
			url: gBASE_URL,
			type: "DELETE",
			async: false,
			success: function (paramOrderRes) {
				callApiAllVouchers();
			},
			error: function (paramErr) {
				console.log(paramErr.status);
			},
		});
	}
</script>
</body>
</html>
